#ifndef __AVL_SID_HPP__
#define __AVL_SID_HPP__

#include "avl.hpp"
#include "string.hpp"

class avl_sid_data
{
  public:
    PSID sid;
    DWORD sid_length;
    string AccounName;
    string DomainName;
    avl_sid_data(PSID new_sid,const unsigned char *new_AccounName=(const unsigned char *)"",const unsigned char *new_DomainName=(const unsigned char *)"");
    ~avl_sid_data();
    void clear(void);
  friend class avl_sid_tree;
};

class avl_sid_tree: public avl_tree<avl_sid_data>
{
  public:
    avl_sid_tree();
    ~avl_sid_tree();
    long compare(avl_node<avl_sid_data> *first,avl_sid_data *second);
    avl_sid_data *query(PSID new_sid);
};

#endif
